#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\decframe.h> 
#include <owl\toolbox.h> 
#include <owl\buttonga.h> 
#include "pr58_1.rc"
 
//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public TDecoratedFrame
{
  public:
	 TWndw (TWindow *parent, const char far *title,
			  TWindow *client);
  protected:
	  TToolBox  *toolBox;
	  void  CmLine  (WPARAM Id);
	  void  CmColor (WPARAM Id);

	  DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TDecoratedFrame)
	EV_COMMAND_AND_ID (CM_LINE1, CmLine),
	EV_COMMAND_AND_ID (CM_LINE2, CmLine),
	EV_COMMAND_AND_ID (CM_LINE3, CmLine),
	EV_COMMAND_AND_ID (CM_LINE4, CmLine),
	EV_COMMAND_AND_ID (CM_BLACK, CmColor),
	EV_COMMAND_AND_ID (CM_BLUE,  CmColor),
	EV_COMMAND_AND_ID (CM_RED,   CmColor),
	EV_COMMAND_AND_ID (CM_GREEN, CmColor),
	EV_COMMAND_AND_ID (CM_YELLOW,CmColor),
	EV_COMMAND_AND_ID (CM_PURPLE,CmColor),
END_RESPONSE_TABLE;

//  -.
class TCWndw : public TWindow
{
  public:
	  TCWndw (TWindow *parent, const char far *title);
  protected:
	  int lineWidth, lineColor;
	  BOOL button;
	  TPen *pen;
	  TClientDC *lineDC;

	  void EvLButtonUp (UINT, TPoint &point);
	  void EvLButtonDown (UINT, TPoint &point);
	  void EvMouseMove (UINT, TPoint &point);
	  LRESULT PmChangeColor (WPARAM color, LPARAM);
	  LRESULT PmChangeLine (WPARAM width, LPARAM);

	  DECLARE_RESPONSE_TABLE (TCWndw);
};

DEFINE_RESPONSE_TABLE1 (TCWndw, TWindow)
	 EV_WM_LBUTTONUP,
	 EV_WM_LBUTTONDOWN,
	 EV_WM_MOUSEMOVE,
	 EV_MESSAGE (PM_CHANGELINE, PmChangeLine),
	 EV_MESSAGE (PM_CHANGECOLOR, PmChangeColor),
END_RESPONSE_TABLE;

//***********************************
//   TWndw.
//***********************************
// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title, TWindow *clienTWndw):
			 TDecoratedFrame (parent, title, clienTWndw)
{
  TButtonGadget *b; 
  TSeparatorGadget *s;
  //     . 
  AssignMenu (MENU_1);
  //     .
  toolBox = new TToolBox (this);
  //     . 
  b = new TButtonGadget (BMP_LINE1, CM_LINE1, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Down); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE2, CM_LINE2, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Up); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE3, CM_LINE3, TButtonGadget::Exclusive,
        TRUE, TButtonGadget::Up); 
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_LINE4, CM_LINE4, TButtonGadget::Exclusive,
		  TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);

  s = new TSeparatorGadget (10);
  toolBox->Insert (*s);
  s = new TSeparatorGadget (10);
  toolBox->Insert (*s);

  b = new TButtonGadget (BMP_BLACK, CM_BLACK, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Down);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_BLUE, CM_BLUE, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_RED, CM_RED, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_GREEN, CM_GREEN, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_YELLOW, CM_YELLOW, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  b = new TButtonGadget (BMP_PURPLE, CM_PURPLE, TButtonGadget::Exclusive,
		 TRUE, TButtonGadget::Up);
  toolBox->Insert (*b);
  //      .
  Insert (*toolBox, TDecoratedFrame::Left);
  //      .
  Attr.X = 50;
  Attr.Y = 50;
  Attr.W = GetSystemMetrics(SM_CXSCREEN)/1.5;
  Attr.H = GetSystemMetrics(SM_CXSCREEN)/1.5;
}

// TWndw::CmLine()
//         
// ,   -.
//   - 
// ,      .
void TWndw::CmLine(WPARAM Id)
{
  ClientWnd->PostMessage(PM_CHANGELINE, Id - 100, 0);
}
// TWndw::CmColor()
//         
// ,   -.
//   -  ,
//      .
void TWndw::CmColor (WPARAM Id)
{
  ClientWnd->PostMessage(PM_CHANGECOLOR, Id - 200, 0);
}

//***********************************
//   TCWndw.
//***********************************
// TCWndw::TCWndw()
//   -.
TCWndw::TCWndw (TWindow *parent, const char far *title):
		  TWindow (parent, title)
{
  //  .
  lineWidth = 1;
  lineColor = 0;
  button = FALSE;
  pen = NULL;
  lineDC = NULL;
}

// TCWndw::EvLButtonDown()
//     WM_LBUTTONDOWN,
//  Windows  , 
//     
//    .
void TCWndw::EvLButtonDown (UINT, TPoint &point)
{
  //     ...
  if (!button)
  {
	 //      .
	 lineDC = new TClientDC (HWindow);
	 pen = new TPen (lineColor, lineWidth, PS_SOLID);
	 lineDC->SelectObject (*pen);
	 //       .
	 SetCapture();
	 //       .
	 lineDC->MoveTo (point);
	 //    .
	 button = TRUE;
  }
}

// TCWndw::EvLButtonUp()
//     WM_LBUTTONUP,
//  Windows  , 
//     .
void TCWndw::EvLButtonUp (UINT, TPoint&)
{
  //   .
  delete lineDC;
  lineDC = NULL;
  //    .
  delete pen;
  //    .
  button = FALSE;
  //      .
  ReleaseCapture();
}

// TCWndw::EvMouseMove()
//     WM_MOUSEMOVE,
//  Windows  , 
//   .
void TCWndw::EvMouseMove (UINT, TPoint &point)
{
  //     ,  
  //    .
  if (button) lineDC->LineTo (point);
}

// TCWndw::PmChangeColor()
//      
//  PM_CHANGECOLOR    .
LRESULT TCWndw::PmChangeColor (WPARAM color, LPARAM)
{
  lineColor = color;
  return 1;
}

// TCWndw::PmChangeLine()
//      
//  PM_CHANGELINE    .
LRESULT TCWndw::PmChangeLine (WPARAM width, LPARAM)
{
  lineWidth = width;
  return 1;
}

//***********************************
//   TApp.
//***********************************
//      .
void TApp::InitMainWindow()
{
  //  -.
  TWindow *client = new TCWndw (0, 0);
  //   .
  TDecoratedFrame *frame = new TWndw (0," ", client);
  //     .
  SetMainWindow(frame);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
